SystemOrganization addCategory: #'PBE-LightsOut'!

SimpleSwitchMorph subclass: #LOCell
	instanceVariableNames: 'mouseAction openInWord'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

LOCell class
	instanceVariableNames: 'offColor bounds onColor'!

!LOCell commentStamp: 'LoCell 4/19/2013 18:13' prior: 0!
A LOCell is one class que sive para un juego.

Instance Variables
	mouseAction:		<Object>

mouseAction
	- xxxxx
!

LOCell class
	instanceVariableNames: 'offColor bounds onColor'!

!LOCell class methodsFor: 'as yet unclassified' stamp: 'LoCell 4/19/2013 18:19'!
initialize
 super initialize.
 self label: ''.
 self borderWidth: 2.
 bounds := 0@0 corner: 16@16.
 offColor := Color paleYellow.
 onColor := Color paleBlue darker.
 self useSquareCorners.
 self turnOff! !

!LOCell methodsFor: 'accessing' stamp: 'sergio.caballero 4/20/2013 10:26'!
mouseAction: aBlock
 ^ mouseAction := aBlock! !

!LOCell methodsFor: 'accessing' stamp: 'sergio.caballero 4/20/2013 10:33'!
mouseUp: anEvent
mouseAction value! !

BorderedMorph subclass: #LOGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOGame commentStamp: 'sergio.caballero 4/20/2013 10:08' prior: 0!
A LOGame is clase que arma el tablero.

Instance Variables
	cells:		<Object>

cells
	- xxxxx
!

!LOGame methodsFor: 'initialization' stamp: 'sergio.caballero 4/20/2013 10:12'!
cellsPerSide
"The number of cells along each side of the game"
^ 10! !

!LOGame methodsFor: 'initialization' stamp: 'sergio.caballero 4/20/2013 09:51'!
initialize
 | sampleCell width height n |
 super initialize.
 n := self cellsPerSide.
 sampleCell := LOCell new.
 width := sampleCell width.
 height := sampleCell height.
 self bounds: (5@5 extent: ((width*n) @(height*n)) + (2 * self borderWidth)).
 cells := Matrix new: n tabulate: [ :i :j | self newCellAt: i at: j ].! !

!LOGame methodsFor: 'as yet unclassified' stamp: 'sergio.caballero 4/20/2013 11:27'!
mouseMove: anEvent! !

!LOGame methodsFor: 'initialization' stamp: 'sergio.caballero 4/20/2013 11:23'!
newCellAt: i at: j
"Create a cell for position (i,j) and add it to my on-screen
representation at the appropriate screen position. Answer the new cell"
| c origin |
c := LOCell new.
origin := self innerBounds origin.
self addMorph: c.
c position: ((i - 1) * c width) @ ((j - 1) * c height) + origin.
c mouseAction: [self toggleNeighboursOfCellAt: i at: j].
^c  ! !

!LOGame methodsFor: 'game logic' stamp: 'sergio.caballero 4/20/2013 10:23'!
toggleNeighboursOfCellAt: i at: j
(i > 1) ifTrue: [ (cells at: i - 1 at: j ) toggleState].
(i < self cellsPerSide) ifTrue: [ (cells at: i + 1 at: j) toggleState].
(j > 1) ifTrue: [ (cells at: i at: j - 1) toggleState].
(j < self cellsPerSide) ifTrue: [ (cells at: i at: j + 1) toggleState].! !
LOCell initialize!
